%define module	setuptools

%define run_test 0
# This controls whether setuptools is build as a wheel or not,
# simplifying Python 3.5 bootstraping process
%define build_wheel 1

%if 0%{?build_wheel}
%define python_wheelname %{module}-%{version}-py2.py3-none-any.whl
%define python_record %{python_sitelib}/%{module}-%{version}.dist-info/RECORD
%define python3_wheelname %python_wheelname
%define python3_record %{python3_sitelib}/%{module}-%{version}.dist-info/RECORD
%endif
 
Summary:	Easily build and distribute Python packages
Name:		python-%{module}
Version:	19.6.2
Release:	%mkrel 1
License:	Python or ZPLv2.0
Group:		Development/Python
Url:		http://pypi.python.org/pypi/%{module}
Source0:	http://pypi.python.org/packages/source/s/%{module}/%{module}-%{version}.tar.gz

BuildArch:	noarch
BuildRequires:	python-devel
BuildRequires:	python-backports-ssl_match_hostname
%if 0%{?build_wheel}
BuildRequires:  python-pip
BuildRequires:  python-wheel
Provides:	pythonegg(2)(setuptools)
Provides:	python2-setuptools
%endif
# For unittests
%if 0%{?run_test}
BuildRequires:	subversion
BuildRequires:  python-pytest
BuildRequires:  python-mock
%endif
Requires:	python-pkg-resources

Provides:	python-setuptools-devel = %{version}-%{release}
Obsoletes:	python-setuptools-devel < 0.7

Provides:	python-distribute = %{version}-%{release}
Obsoletes:	python-distribute < 0.7

%description
A collection of enhancements to the Python distutils that allow 
you to more easily build and distribute Python packages, especially 
ones that have dependencies on other packages.


%package -n python3-%{module}
Summary:	Easily build and distribute Python3 packages
Group:		Development/Python

BuildRequires:	python3-devel
%if 0%{?run_test}
BuildRequires:  python3-pytest
BuildRequires:  python3-mock
%endif
%if 0%{?build_wheel}
BuildRequires:  python3-pip
BuildRequires:  python3-wheel
Provides:       pythonegg(3)(setuptools)
%endif
Requires:	python3-pkg-resources

Provides:	python3-setuptools-devel = %{version}-%{release}
Obsoletes:	python3-setuptools-devel < 0.7

Provides:	python3-distribute = %{version}-%{release}
Obsoletes:	python3-distribute < 0.7

%description -n python3-setuptools
A collection of enhancements to the Python 3 distutils that allow
you to more easily build and distribute Python 3 packages, especially
ones that have dependencies on other packages.


%package -n python-pkg-resources
Summary: Runtime module to access python resources
Group:		Development/Python

%description -n python-pkg-resources
Module used to find and manage Python package/version dependencies and access
bundled files and resources, including those inside of zipped .egg files.


%package -n python3-pkg-resources
Summary: Runtime module to access python 3 resources
Group:		Development/Python

%description -n python3-pkg-resources
Module used to find and manage Python 3 package/version dependencies and access
bundled files and resources, including those inside of zipped .egg files.


%prep
%setup -q -n %{module}-%{version}

find -name '*.txt' -exec chmod -x \{\} \;
find . -name '*.orig' -exec rm \{\} \;
# remove tests that can't be run on the BS
rm setuptools/tests/test_integration.py 
rm setuptools/tests/test_sdist.py
rm setuptools/tests/test_easy_install.py

rm -f setuptools/*.exe

cp -a . %{py3dir}
pushd %{py3dir}
for file in setuptools/command/easy_install.py ; do
    sed -i '1s|^#!python|#!%{__python3}|' $file
done
popd

for file in setuptools/command/easy_install.py ; do
    sed -i '1s|^#!python|#!%{__python}|' $file
done

%build
%if 0%{?build_wheel}
%{__python} setup.py bdist_wheel
%else
%py2_build
%endif

pushd %{py3dir}
%if 0%{?build_wheel}
%{__python3} setup.py bdist_wheel
%else
%py3_build
%endif
popd

%install
# Must do the python3 install first because the scripts in /usr/bin are
# overwritten with every setup.py install (and we want the python2 version
# to be the default for now).
pushd %{py3dir}
%if 0%{?build_wheel}
pip3 install -I dist/%{python3_wheelname} --root %{buildroot} --strip-file-prefix %{buildroot}

# TODO: we have to remove this by hand now, but it'd be nice if we wouldn't have to
# (pip install wheel doesn't overwrite)
rm %{buildroot}%{_bindir}/easy_install

sed -i '/\/usr\/bin\/easy_install,/d' %{buildroot}%{python3_record}
%else
%py3_install
%endif

rm -rf %{buildroot}%{python3_sitelib}/setuptools/tests
%if 0%{?build_wheel}
sed -i '/^setuptools\/tests\//d' %{buildroot}%{python3_record}
%endif

find %{buildroot}%{python3_sitelib} -name '*.exe' | xargs rm -f
chmod +x %{buildroot}%{python3_sitelib}/setuptools/command/easy_install.py
popd

%if 0%{?build_wheel}
pip2 install -I dist/%{python_wheelname} --root %{buildroot} --strip-file-prefix %{buildroot}
%else
%py2_install
%endif

rm -rf %{buildroot}%{python_sitelib}/setuptools/tests
%if 0%{?build_wheel}
sed -i '/^setuptools\/tests\//d' %{buildroot}%{python_record}
%endif

find %{buildroot}%{python_sitelib} -name '*.exe' | xargs rm -f
chmod +x %{buildroot}%{python_sitelib}/setuptools/command/easy_install.py

%if 0%{?run_test}
%check
PYTHONPATH=$(pwd) py.test

pushd %{py3dir}
PYTHONPATH=$(pwd) py.test-%{python3_version}
popd
%endif

%files
%doc *.txt docs
%{_bindir}/easy_install
%{_bindir}/easy_install-2.*
%{python_sitelib}/*
%exclude %{python_sitelib}/pkg_resources

%files -n python-pkg-resources
%{python_sitelib}/pkg_resources

%files -n python3-setuptools
%doc *.txt docs
%{_bindir}/easy_install-3.*
%{python3_sitelib}/*
%exclude %{python3_sitelib}/pkg_resources

%files -n python3-pkg-resources
%{python3_sitelib}/pkg_resources

